diff --git a/yum/__init__.py b/yum/__init__.py
index 04f2aac..27eb5c2 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -665,7 +665,10 @@ class YumBase(depsolve.Depsolve):
         # Try another depsolve
         if self.conf.skip_broken and rescode==1:
             self.skipped_packages = []    # reset the public list of skipped packages.
+            sb_st = time.time()
             rescode, restring = self._skipPackagesWithProblems(rescode, restring)
+            self._printTransaction()        
+            self.verbose_logger.debug('Skip-Broken time: %0.3f' % (time.time() - sb_st))
 
         self.verbose_logger.debug('Depsolve time: %0.3f' % (time.time() - ds_st))
         return rescode, restring
@@ -681,21 +684,28 @@ class YumBase(depsolve.Depsolve):
             _remove_from_sack(po)
 
         def _remove_from_sack(po):
-            if not po.repoid == 'installed' and po not in removed_from_sack:
-                self.verbose_logger.debug('SKIPBROKEN: removing %s from pkgSack & updates' % str(po))
-                self.pkgSack.delPackage(po)
-                self.up.delPackage(po.pkgtup)
-                removed_from_sack.add(po)
+            # get all compatible arch packages from pkgSack
+            # we need to remove them to so a i386 paqckages is not 
+            # dragged in when a x86_64 is skipped.
+            pkgs = self._getPackagesToRemoveAllArch(po)
+            for pkg in pkgs:
+                if not po.repoid == 'installed' and pkg not in removed_from_sack:             
+                    self.verbose_logger.debug('SKIPBROKEN: removing %s from pkgSack & updates' % str(po))
+                    self.pkgSack.delPackage(pkg)
+                    self.up.delPackage(pkg.pkgtup)
+                    removed_from_sack.add(pkg)
 
         # Keep removing packages & Depsolve until all errors is gone
         # or the transaction is empty
         count = 0
         skipped_po = set()
         removed_from_sack = set()
-        orig_restring = restring    # Keep the old error messages
-        while len(self.po_with_problems) > 0 and rescode == 1:
+        orig_restring = restring    # Keep the old error messages 
+        looping = 0 
+        while (len(self.po_with_problems) > 0 and rescode == 1):
             count += 1
             self.verbose_logger.debug(_("Skip-broken round %i"), count)
+            self._printTransaction()        
             depTree = self._buildDepTree()
             startTs = set(self.tsInfo)
             toRemove = set()
@@ -712,14 +722,39 @@ class YumBase(depsolve.Depsolve):
                     # make sure we get the compat arch packages skip from pkgSack and up too.
                     if skip not in removed_from_sack and skip.repoid == 'installed':
                         _remove_from_sack(skip)
-            if not toRemove: # Nothing was removed, so we still got a problem
-                break # Bail out
+            # Nothing was removed, so we still got a problem
+             # the first time we get here we reset the resolved members of
+             # tsInfo and takes a new run all members in the current transaction
+            if not toRemove: 
+                looping += 1
+                if looping > 2:
+                    break # Bail out
+                else:
+                    self.verbose_logger.debug('SKIPBROKEN: resetting already resovled packages (no packages to skip)' )
+                    self.tsInfo.resetResolved(hard=True)
             rescode, restring = self.resolveDeps()
             endTs = set(self.tsInfo)
              # Check if tsInfo has changes since we started to skip packages
              # if there is no changes then we got a loop.
+             # the first time we get here we reset the resolved members of
+             # tsInfo and takes a new run all members in the current transaction
             if startTs-endTs == set():
-                break    # bail out
+                looping += 1
+                if looping > 2:
+                    break # Bail out
+                else:
+                    self.verbose_logger.debug('SKIPBROKEN: resetting already resovled packages (transaction not changed)' )
+                    self.tsInfo.resetResolved(hard=True)
+                    
+            # if we are alel clear, then we have to check that the whole current transaction 
+            # can complete the depsolve without error, because the packages skipped
+            # can have broken something that passed the tests earliere.
+            # FIXME: We need do this in a better way.
+            if rescode != 1:
+                self.verbose_logger.debug('SKIPBROKEN: sanity check the current transaction' )
+                self.tsInfo.resetResolved(hard=True)
+                self._checkMissingObsoleted() # This is totally insane, but needed :(
+                rescode, restring = self.resolveDeps()
         if rescode != 1:
             self.verbose_logger.debug(_("Skip-broken took %i rounds "), count)
             self.verbose_logger.info(_('\nPackages skipped because of dependency problems:'))
@@ -733,9 +768,46 @@ class YumBase(depsolve.Depsolve):
             # If we cant solve the problems the show the original error messages.
             self.verbose_logger.info("Skip-broken could not solve problems")
             return 1, orig_restring
-        
         return rescode, restring
 
+    def _checkMissingObsoleted(self):
+        """ 
+        If multiple packages is obsoleting the same package
+        then the TS_OBSOLETED can get removed from the transaction
+        so we must make sure that they, exist and else create them
+        """
+        for txmbr in self.tsInfo:
+            for pkg in txmbr.obsoletes:
+                if not self.tsInfo.exists(pkg.pkgtup):
+                    obs = self.tsInfo.addObsoleted(pkg,txmbr.po)
+                    self.verbose_logger.debug('SKIPBROKEN: Added missing obsoleted %s (%s)' % (pkg,txmbr.po) )
+            for pkg in txmbr.obsoleted_by:
+                # check if the obsoleting txmbr is in the transaction
+                # else remove the obsoleted txmbr
+                # it clean out some really wierd cases
+                if not self.tsInfo.exists(pkg.pkgtup):
+                    self.verbose_logger.debug('SKIPBROKEN: Remove extra obsoleted %s (%s)' % (txmbr.po,pkg) )
+                    self.tsInfo.remove(txmbr.po.pkgtup)
+
+    def _getPackagesToRemoveAllArch(self,po):
+        ''' get all compatible arch packages in pkgSack'''
+        pkgs = []
+        if rpmUtils.arch.isMultiLibArch():
+            archs = rpmUtils.arch.getArchList() 
+            n,a,e,v,r = po.pkgtup
+            # skip for all compat archs
+            for a in archs:
+                pkgtup = (n,a,e,v,r)
+                matched = self.pkgSack.searchNevra(n,e,v,r,a) 
+                pkgs.extend(matched)
+        else:
+            pkgs.append(po)
+        return pkgs   
+        
+                
+                
+        
+
     def _skipFromTransaction(self,po):
         skipped =  []
         if rpmUtils.arch.isMultiLibArch():
@@ -778,6 +850,26 @@ class YumBase(depsolve.Depsolve):
             for p in l:
                 print "\t", p
 
+    def _printTransaction(self):
+        #transaction set states
+        state = { TS_UPDATE     : "update",
+                  TS_INSTALL    : "install",
+                  TS_TRUEINSTALL: "trueinstall",
+                  TS_ERASE      : "erase",
+                  TS_OBSOLETED  : "obsoleted",
+                  TS_OBSOLETING : "obsoleting",
+                  TS_AVAILABLE  : "available",
+                  TS_UPDATED    : "updated"}
+
+        self.verbose_logger.log(logginglevels.DEBUG_2,"TSINFO: Current Transaction : %i member(s) " % len(self.tsInfo))
+        for txmbr in self.tsInfo:
+            msg = "  %-11s : %s " % (state[txmbr.output_state],txmbr.po)
+            self.verbose_logger.log(logginglevels.DEBUG_2, msg)
+            for po,rel in txmbr.relatedto:
+                msg = "                   %s : %s" % (rel,po)
+                self.verbose_logger.log(logginglevels.DEBUG_2, msg)
+                
+                                    
     def _getPackagesToRemove(self,po,deptree,toRemove):
         '''
         get the (related) pos to remove.
@@ -1371,7 +1463,7 @@ class YumBase(depsolve.Depsolve):
         return self._cleanFiles(exts, 'cachedir', 'sqlite')
 
     def cleanMetadata(self):
-        exts = ['xml.gz', 'xml', 'cachecookie', 'mirrorlist.txt']
+        exts = ['xml.gz', 'xml', 'cachecookie', 'mirrorlist.txt', 'asc']
         # Metalink is also here, but is a *.xml file
         return self._cleanFiles(exts, 'cachedir', 'metadata') 
 
@@ -1412,6 +1504,8 @@ class YumBase(depsolve.Depsolve):
         
         installed = []
         available = []
+        reinstall_available = []
+        old_available = []
         updates = []
         obsoletes = []
         obsoletesTuples = []
@@ -1437,7 +1531,6 @@ class YumBase(depsolve.Depsolve):
                 avail = self.pkgSack.returnPackages(patterns=patterns,
                                                     ignore_case=ic)
             else:
-                del dinst # Using ndinst instead
                 try:
                   avail = self.pkgSack.returnNewestByNameArch(patterns=patterns,
                                                               ignore_case=ic)
@@ -1446,12 +1539,18 @@ class YumBase(depsolve.Depsolve):
             
             for pkg in avail:
                 if showdups:
-                    if pkg.pkgtup not in dinst:
+                    if pkg.pkgtup in dinst:
+                        reinstall_available.append(pkg)
+                    else:
                         available.append(pkg)
                 else:
                     key = (pkg.name, pkg.arch)
-                    if key not in ndinst or pkg.verGT(ndinst[key]):
+                    if pkg.pkgtup in dinst:
+                        reinstall_available.append(pkg)
+                    elif key not in ndinst or pkg.verGT(ndinst[key]):
                         available.append(pkg)
+                    else:
+                        old_available.append(pkg)
 
         # produce the updates list of tuples
         elif pkgnarrow == 'updates':
@@ -1489,12 +1588,20 @@ class YumBase(depsolve.Depsolve):
             
             for pkg in avail:
                 if showdups:
-                    if not self.rpmdb.contains(po=pkg):
+                    if self.rpmdb.contains(po=pkg):
+                        reinstall_available.append(pkg)
+                    else:
                         available.append(pkg)
                 else:
                     ipkgs = self.rpmdb.searchNevra(pkg.name, arch=pkg.arch)
-                    if not ipkgs or pkg.verGT(sorted(ipkgs, reverse=True)[0]):
+                    if ipkgs:
+                        latest = sorted(ipkgs, reverse=True)[0]
+                    if not ipkgs or pkg.verGT(latest):
                         available.append(pkg)
+                    elif pkg.verEQ(latest):
+                        reinstall_available.append(pkg)
+                    else:
+                        old_available.append(pkg)
 
         # not in a repo but installed
         elif pkgnarrow == 'extras':
@@ -1550,6 +1657,8 @@ class YumBase(depsolve.Depsolve):
         
         ygh.installed = installed
         ygh.available = available
+        ygh.reinstall_available = reinstall_available
+        ygh.old_available = old_available
         ygh.updates = updates
         ygh.obsoletes = obsoletes
         ygh.obsoletesTuples = obsoletesTuples
@@ -1808,7 +1917,7 @@ class YumBase(depsolve.Depsolve):
             
         return matches
 
-    def doGroupLists(self, uservisible=0):
+    def doGroupLists(self, uservisible=0, patterns=None, ignore_case=True):
         """returns two lists of groups, installed groups and available groups
            optional 'uservisible' bool to tell it whether or not to return
            only groups marked as uservisible"""
@@ -1820,7 +1929,12 @@ class YumBase(depsolve.Depsolve):
         if self.comps.compscount == 0:
             raise Errors.GroupsError, _('No group data available for configured repositories')
         
-        for grp in self.comps.groups:
+        if patterns is None:
+            grps = self.comps.groups
+        else:
+            grps = self.comps.return_groups(",".join(patterns),
+                                            case_sensitive=not ignore_case)
+        for grp in grps:
             if grp.installed:
                 if uservisible:
                     if grp.user_visible:
@@ -2288,6 +2402,15 @@ class YumBase(depsolve.Depsolve):
             tx_return.extend(txmbrs)
         return tx_return
 
+    def _find_obsoletees(self, po):
+        """ Return the pkgs. that are obsoleted by the po we pass in. """
+        for (obstup, inst_tup) in self.up.getObsoletesTuples(name=po.name, 
+                                                             arch=po.arch):
+            if po.pkgtup == obstup:
+                installed_pkg =  self.rpmdb.searchPkgTuple(inst_tup)[0]
+                yield installed_pkg
+
+
     def install(self, po=None, **kwargs):
         """try to mark for install the item specified. Uses provided package 
            object, if available. If not it uses the kwargs and gets the best
@@ -2421,6 +2544,16 @@ class YumBase(depsolve.Depsolve):
                 tx_return.extend(txmbrs)
                 continue
             
+            #  Make sure we're not installing a package which is obsoleted by
+            # something else in the repo. Unless there is a obsoletion loop,
+            # at which point ignore everything.
+            obsoleting_pkg = self._test_loop(po, self._pkg2obspkg)
+            if obsoleting_pkg is not None:
+                self.verbose_logger.warning(_('Package %s is obsoleted by %s, trying to install %s instead'),
+                    po.name, obsoleting_pkg.name, obsoleting_pkg)               
+                self.install(po=obsoleting_pkg)
+                continue
+            
             # make sure it's not already installed
             if self.rpmdb.contains(po=po):
                 if not self.tsInfo.getMembersWithState(po.pkgtup, TS_REMOVE_STATES):
@@ -2436,18 +2569,25 @@ class YumBase(depsolve.Depsolve):
                     tx_return.extend(txmbrs)
                     continue
 
-            #  Make sure we're not installing a package which is obsoleted by
-            # something else in the repo. Unless there is a obsoletion loop,
-            # at which point ignore everything.
-            obsoleting_pkg = self._test_loop(po, self._pkg2obspkg)
-            if obsoleting_pkg is not None:
-                self.verbose_logger.warning(_('Package %s is obsoleted by %s, trying to install %s instead'),
-                    po.name, obsoleting_pkg.name, obsoleting_pkg)               
-                self.install(po=obsoleting_pkg)
-                continue
                 
-            txmbr = self.tsInfo.addInstall(po)
-            tx_return.append(txmbr)
+            # at this point we are going to mark the pkg to be installed, make sure
+            # it's not an older package that is allowed in due to multiple installs
+            # or some other oddity. If it is - then modify the problem filter to cope
+            
+            for ipkg in self.rpmdb.searchNevra(name=po.name, arch=po.arch):
+                if ipkg.EVR > po.EVR:
+                    self.tsInfo.probFilterFlags.append(rpm.RPMPROB_FILTER_OLDPACKAGE)
+                    break
+            
+            # it doesn't obsolete anything. If it does, mark that in the tsInfo, too
+            if po.pkgtup in self.up.getObsoletesList(name=po.name, arch=po.arch):
+                for obsoletee in self._find_obsoletees(po):
+                    txmbr = self.tsInfo.addObsoleting(po, obsoletee)
+                    self.tsInfo.addObsoleted(obsoletee, po)
+                    tx_return.append(txmbr)
+            else:
+                txmbr = self.tsInfo.addInstall(po)
+                tx_return.append(txmbr)
         
         return tx_return
 
@@ -2503,15 +2643,15 @@ class YumBase(depsolve.Depsolve):
         # if no po do kwargs
         # uninstalled pkgs called for update get returned with errors in a list, maybe?
 
-        updates = self.up.getUpdatesTuples()
-        if self.conf.obsoletes:
-            obsoletes = self.up.getObsoletesTuples(newest=1)
-        else:
-            obsoletes = []
-
         tx_return = []
         if not po and not kwargs: # update everything (the easy case)
             self.verbose_logger.log(logginglevels.DEBUG_2, _('Updating Everything'))
+            updates = self.up.getUpdatesTuples()
+            if self.conf.obsoletes:
+                obsoletes = self.up.getObsoletesTuples(newest=1)
+            else:
+                obsoletes = []
+
             for (obsoleting, installed) in obsoletes:
                 obsoleting_pkg = self.getPackageObject(obsoleting)
                 installed_pkg =  self.rpmdb.searchPkgTuple(installed)[0]
@@ -2526,12 +2666,7 @@ class YumBase(depsolve.Depsolve):
                     self.verbose_logger.log(logginglevels.DEBUG_2, _('Not Updating Package that is already obsoleted: %s.%s %s:%s-%s'), 
                         old)
                 else:
-                    updating_pkg = self.getPackageObject(new)
-                    updated_pkg = self.rpmdb.searchPkgTuple(old)[0]
-                    txmbr = self.tsInfo.addUpdate(updating_pkg, updated_pkg)
-                    if requiringPo:
-                        txmbr.setAsDep(requiringPo)
-                    tx_return.append(txmbr)
+                    tx_return.extend(self.update(po=self.getPackageObject(new)))
             
             return tx_return
 
@@ -2557,8 +2692,23 @@ class YumBase(depsolve.Depsolve):
             instpkgs.extend(e)
             instpkgs.extend(m)
 
-            # if we can't find an installed package then look at available pkgs
-            if not instpkgs:
+            if u:
+                depmatches = []
+                arg = u[0]
+                try:
+                    depmatches = self.returnInstalledPackagesByDep(arg)
+                except yum.Errors.YumBaseError, e:
+                    self.logger.critical(_('%s') % e)
+                
+                if not depmatches:
+                    self.logger.critical(_('No Match for argument: %s') % arg)
+                else:
+                    instpkgs.extend(depmatches)
+
+            #  Always look for available packages, it doesn't seem to do any
+            # harm (apart from some time). And it fixes weird edge cases where
+            # "update a" (which requires a new b) is different from "update b"
+            if True or not instpkgs:
                 (e, m, u) = self.pkgSack.matchPackageNames([kwargs['pattern']])
                 availpkgs.extend(e)
                 availpkgs.extend(m)
@@ -2605,12 +2755,7 @@ class YumBase(depsolve.Depsolve):
             for installed_pkg in instpkgs:
                 for obsoleting in self.up.obsoleted_dict.get(installed_pkg.pkgtup, []):
                     obsoleting_pkg = self.getPackageObject(obsoleting)
-                    # FIXME check for what might be in there here
-                    txmbr = self.tsInfo.addObsoleting(obsoleting_pkg, installed_pkg)
-                    self.tsInfo.addObsoleted(installed_pkg, obsoleting_pkg)
-                    if requiringPo:
-                        txmbr.setAsDep(requiringPo)
-                    tx_return.append(txmbr)
+                    tx_return.extend(self.install(po=obsoleting_pkg))
             for available_pkg in availpkgs:
                 for obsoleted in self.up.obsoleting_dict.get(available_pkg.pkgtup, []):
                     obsoleted_pkg = self.getInstalledPackageObject(obsoleted)
@@ -2626,12 +2771,23 @@ class YumBase(depsolve.Depsolve):
 
         for installed_pkg in instpkgs:
             for updating in self.up.updatesdict.get(installed_pkg.pkgtup, []):
-                updating_pkg = self.getPackageObject(updating)
+                po = self.getPackageObject(updating)
                 if self.tsInfo.isObsoleted(installed_pkg.pkgtup):
                     self.verbose_logger.log(logginglevels.DEBUG_2, _('Not Updating Package that is already obsoleted: %s.%s %s:%s-%s'), 
                                             installed_pkg.pkgtup)                                               
+                # at this point we are going to mark the pkg to be installed, make sure
+                # it doesn't obsolete anything. If it does, mark that in the tsInfo, too
+                elif po.pkgtup in self.up.getObsoletesList(name=po.name,
+                                                           arch=po.arch):
+                    for obsoletee in self._find_obsoletees(po):
+                        txmbr = self.tsInfo.addUpdate(po, installed_pkg)
+                        if requiringPo:
+                            txmbr.setAsDep(requiringPo)
+                        self.tsInfo.addObsoleting(po, obsoletee)
+                        self.tsInfo.addObsoleted(obsoletee, po)
+                        tx_return.append(txmbr)
                 else:
-                    txmbr = self.tsInfo.addUpdate(updating_pkg, installed_pkg)
+                    txmbr = self.tsInfo.addUpdate(po, installed_pkg)
                     if requiringPo:
                         txmbr.setAsDep(requiringPo)
                     tx_return.append(txmbr)
@@ -3184,7 +3340,8 @@ class YumBase(depsolve.Depsolve):
             if msgs:
                 retmsgs = [_('ERROR with rpm_check_debug vs depsolve:')]
                 retmsgs.extend(msgs) 
-                retmsgs.append(_('Please report this error in bugzilla'))
+                retmsgs.append(_('Please report this error at %s') 
+                                             % self.conf.bugtracker_url)
                 raise Errors.YumRPMCheckError,retmsgs
         
         tsConf = {}
diff --git a/yum/comps.py b/yum/comps.py
index ee9f187..6820c64 100755
--- a/yum/comps.py
+++ b/yum/comps.py
@@ -247,8 +247,8 @@ class Group(CompsObj):
    <id>%s</id>
    <default>%s</default>
    <uservisible>%s</uservisible>
-   <display_order>%s</display_order>\n""" % (self.groupid, str(self.default), 
-                                  str(self.user_visible), self.display_order)
+   <display_order>%s</display_order>\n""" % (self.groupid, str(self.default).lower(), 
+                                  str(self.user_visible).lower(), self.display_order)
    
         if self.langonly:
             msg += """   <langonly>%s</langonly>""" % self.langonly
@@ -354,7 +354,7 @@ class Category(CompsObj):
                 self.translated_description[lang] = obj.translated_description[lang]
 
     def xml(self):
-        """write out an xml stanza for the group object"""
+        """write out an xml stanza for the category object"""
         msg ="""        
   <category>
    <id>%s</id>
diff --git a/yum/config.py b/yum/config.py
index 03123a9..2219605 100644
--- a/yum/config.py
+++ b/yum/config.py
@@ -637,7 +637,7 @@ class YumConf(StartupConf):
     # FIXME: rename gpgcheck to pkgs_gpgcheck
     gpgcheck = BoolOption(__pkgs_gpgcheck_default__)
     repo_gpgcheck = BoolOption(__repo_gpgcheck_default__)
-    obsoletes = BoolOption(False)
+    obsoletes = BoolOption(True)
     showdupesfromrepos = BoolOption(False)
     enabled = BoolOption(True)
     enablegroups = BoolOption(True)
@@ -667,7 +667,23 @@ class YumConf(StartupConf):
                  # all == install any/all arches you can
                  # best == use the 'best  arch' for the system
                  
-
+    bugtracker_url = Option('http://yum.baseurl.org/report')
+
+    color = SelectionOption('auto', ('auto', 'never', 'always'),
+                            mapper={'on' : 'always', 'yes' : 'always',
+                                    '1' : 'always', 'true' : 'always',
+                                    'off' : 'never', 'no' : 'never',
+                                    '0' : 'never', 'false' : 'never',
+                                    'tty' : 'auto', 'if-tty' : 'auto'})
+    color_list_installed_older = Option('bold')
+    color_list_installed_newer = Option('bold,yellow')
+    color_list_installed_extra = Option('bold,red')
+
+    color_list_available_upgrade = Option('bold,blue')
+    color_list_available_downgrade = Option('dim,cyan')
+    color_list_available_install = Option('normal')
+
+    color_search_match = Option('bold')
     
     _reposlist = []
 
